#!/usr/bin/python2.5
import gettext
import math
import os
import locale
try:
     from gnome import gconf
except:
     import gconf

try:
    import sqlite3
except:
    from pysqlite2 import dbapi2 as sqlite3


     
#cur_locale=locale.getlocale()
gettext.textdomain('sayhoo')
_ = gettext.gettext


#locale.setlocale(locale.LC_ALL, "fr_FR")
#os.environ["LANGUAGE"]="fr_FR"

cur_locale=locale.getlocale()
print "Locale=",cur_locale
print _('This is a translatable string.')


gconf_default=gconf.client_get_default()
gconf_root="/apps/osso/sayhoo"


EARTH_RADIUS=3443.91847


def is_maemo():
     if os.name=="posix" and os.path.exists('/media/mmc1'):
         return True
     else:
         return False
    
def deg2rad(deg):
    out = (deg) * (math.pi / 180.0)
    return out

def rad2deg(rad):
    out=(rad) * (180.0 / math.pi)
    return out



class Event:
    """this is a superclass for any events that might be generated by an
    object and sent to the EventManager
    """
    def __init__(self,name="Generic Event"):
        self.name = name

class TickEvent(Event):
    def __init__(self,name="TickEvent"):
        Event.__init__(self,name=name)

class StartEvent(Event):
    def __init__(self,name="StartEvent"):
        Event.__init__(self,name=name)

class StopEvent(Event):
    def __init__(self,name="StopEvent"):
        Event.__init__(self,name=name)

class GuiRequest(Event):
    def __init__(self,name="GuiRequest",args={}):
        Event.__init__(self,name=name)
        self.args=args

class GuiAnswer(Event):
    def __init__(self,name="GuiAnswer",args={},answer=False):
        Event.__init__(self,name=name)
        self.args=args
        self.answer=answer
        
class MapRequest(Event):
    def __init__(self,name="MapRequest",args={}):
        Event.__init__(self,name=name)
        self.args=args

class MapAnswer(Event):
    def __init__(self,name="MapAnswer",args={},answer=False):
        Event.__init__(self,name=name)
        self.args=args
        self.answer=answer

class GpsEvent(Event):
    def __init__(self,name="GpsEvent",args={}):
        Event.__init__(self,name=name)
        self.args=args
        

class TtsEvent(Event):
    def __init__(self,name="TtsEvent",args={}):
        Event.__init__(self,name=name)
        self.args=args
        

tick_per_sec=10.0

if is_maemo():
     import osso
     osso_context = osso.Context("org.maemo.sayhoo", "0.0.1", False)
     osso_rpc=osso.Rpc(osso_context)

     #db_location="/media/mmc2/data-sayhoo/osm.db"
     #tiles_location="/media/mmc2/data-sayhoo/tiles/%s/%s/%s.png"
     glade_file_location="/usr/share/sayhoo/data/sayhoo.glade"
     #pickle_jar="/media/mmc2/data-sayhoo/pickle-jar"

     def system_info(message):
          sysnote=osso.SystemNote(osso_context)
          sysnote.system_note_infoprint(message)

else:
     osso_context=False
     osso_rpc=False
     #db_location="/media/mmc2/data-sayhoo/osm.db"
     #tiles_location="/media/mmc2/data-sayhoo/tiles/%s/%s/%s.png"
     glade_file_location="/home/user/scratchome/dev/sayhoo/branches/pamadio/data/sayhoo.glade"
     #pickle_jar="/media/mmc2/data-sayhoo/pickle-jar"

     def system_info(message):
          print "System Info: '%s'"%message



def find_center_point(db_loc):
     print "find_center_point for",db_loc
     db=sqlite3.connect(db_loc)
     cursor=db.cursor()
     snt="select min(lat),max(lat),min(lon),max(lon) from nodes"
     cursor.execute(snt)
     line=cursor.fetchone()
     min_lat=line[0]
     max_lat=line[1]
     min_lon=line[2]
     max_lon=line[3]
     lat=min_lat+(max_lat-min_lat)/2.0
     lon=min_lon+(max_lon-min_lon)/2.0
     db.close()
     return (lat,lon)

          
if gconf_default.get_string(gconf_root+"/city_data_dir"):
     """
     gconftool-2 -t string -s '/apps/osso/sayhoo/city_data_dir' '/media/mmc2/data-sayhoo'
     gconftool-2 -u '/apps/osso/sayhoo' --recursive-unset
     """
     city_data_dir=gconf_default.get_string(gconf_root+"/city_data_dir")
     db_location=city_data_dir+"/osm.db"
     tiles_location=city_data_dir+"/tiles/%s/%s/%s.png"
     pickle_jar=city_data_dir+"/pickle-jar"
     #start_view_lat=48.8587771
     #start_view_lon=2.293387

     (start_view_lat,start_view_lon)=find_center_point(db_location)
     
else:
     city_data_dir=False     
     db_location=city_data_dir
     tiles_location=city_data_dir
     pickle_jar=city_data_dir
     start_view_lat=False
     start_view_lon=False


